/*-----------------------------------------------------------------
/					 Fichier d'entete CAvatar.h						
/------------------------------------------------------------------
Role: dclaration de la classe CBombe
-------------------------------------------------------------------
Versions: 
-------------------------------------------------------------------
23/12/02: regroupement des modifs de Fran et Guillaume
	Rajout des variables utiles  l'animation
02/01/03: Francois - rennomage de _images en _tabImages pour ne pas
	confondre avec _image de la classe CSDLSprite
02/01/03: Francois - modification du constructeur
08/01/03: (G) - deux nouveaux attributs: _finInvicibilite et _estInvincible
[1/16/2003] Francois - creation de setABombeTelecommandeesTRUE()
			+ ajout de _aBombeTelecommandee
------------------------------------------------------------------*/

#if !defined(CAvatar_h)
#define CAvatar_h


#include "CContenu.h"
#include "CSDLSprite.h"
#include "CCase.h"
#include "CGestionnaireEntree.h"
#include "utils.h"
#include "CBombe.h"
#include "CBonus.h"
#include "CFMODWrapper.h"
#include "CFMODMusique.h"

class CBombe;
class tableauDeCases;
class CCase;
class CBonus;


class CAvatar : public CContenu
{
public:
	
	CAvatar(int nbBombesPosables, int dureeDeVieDeLaBombe,
			int dureeDeVieDeLaFlamme, CGestionnaireEntree * ptGestEntree,
			CRound * leRound, int numero, SDL_Surface * ecran);

	virtual ~CAvatar();

	//fonction type accesseur, utilisee par la classe bonus 
	//afin de modifier les proprietes de l'avatar
	void incrementerNbBombesPosables();
	void incrementerPorteeBombes();
	void incrementerVitesse();
    void rendreInvincible();
	void donnerBombesTelecommandees()
	{ _aBombeTelecommandee = true;	}

	void CAvatar::explose();
	int continueDestruction();
	inline bool estTraversable()
	{	return true;	}		// un avatar peut traverser 1 autre avatar
	inline bool estInvincible()
	{	return (_estInvincible); }
	inline void setABombeTelecommandeesTRUE()
	{	_aBombeTelecommandee = true; }

	void initialiserCaseDepart(int x, int y);
	void afficheToi(SDL_Rect coord_info, SDL_Surface * screen);
	void detacherBombe(CBombe * ptBombe);

	static void staticInit();
	static void staticDestruct();


protected:
	void vis2();
    void deplacer(SDeplacement essaiDeplacement);
    void agir(SAction essaiAction);

private:

    int	_nbBombesPosables;
    int	_dureeDeVieDeLaBombe;	// en millisecondes
    int	_dureeDeVieDeLaFlamme;	// en millisecondes
	CGestionnaireEntree * _ptGestEntree;
	CRound * _ptRound;
	int _numeroAvatar;	// sert a differencier les differents Avatars. De plus, c'est un moyen pour le
						// gestionnaire de controles de differencier les avatars, et pour charger les
						//images.

	int	_xSurCase;
	int	_ySurCase;
	int _porteeDeLaBombe;
    CCase * _ptCaseActuelle;
	int _xCase;
	int _yCase;
	bool _caseDepartEstInitialisee;
	
	vector<CBombe*> _vectMesBombes;
	list<CBombe*> _listMesBombesTelecommandees;

	static CBruitage _tabBruitageMort[NB_BRUITAGES_MORT];
	static CBruitage _sonPoserBombe;
	CFMODMusique _aura;

	//Pour l'animation:
	int _imageCourante;
	bool _bouge;		//indique si l'avatar bouge
	int _delai;			//delai entre 2 images
	Uint32 _next;		//prochain temps de mvt
	int _nbImages;
	SDL_Surface * _tabImages[5][3];
	SDL_Surface * _imageAura;
	sens_propagation _sensMouvement;
	
	//donnes pr le bonus d'invincibilite
	Uint32 _finInvicibilite;
	bool _estInvincible;

	bool _aBombeTelecommandee;
    
};

#endif /* CAvatar_h */
