/*-----------------------------------------------------------------
/					 Fichier  CCase.cpp						
/------------------------------------------------------------------
Role: Dfinition de la classe CCase
-------------------------------------------------------------------
Versions: (depuis regroupement du 22/12/02)
-------------------------------------------------------------------
23/12/02: regroupement des modifs de Fran et Guillaume
	Modif de la fonction poserFlamme qui transmet ses paramtres
	au constructeur de Cflamme.
	Cration de la fonction peutSePropager 
------------------------------------------------------------------*/

#if !defined(CCase_h)
#define CCase_h

//POUR DEBUGGAGE:
//si estMurIndestructible == false et si estMurDestructible ==
//false alors la case est consideree comme une case libre/ocupable
//On peut arreter le programme si jamais on detecte un etat
//incohrent (cad les 2 booleens a true) => presence d'assert(...)

#include "CSDLSprite.h"
#include "CRound.h"
#include "CContenu.h"
#include "utils.h"
#include "CFlamme.h"


class CRound;


// CCase derive de vector<CContenu*>, comme ca on peut parcourir
// tout naturellement la case pour acceder a son contenu
class CCase : public CSDLSprite, public list<CContenu*>
{
	public:
		CCase(type_case type, CContenu * contenuDeDepart);
		virtual ~CCase();

		// A appeler OBLIGATOIREMENT apres la creation des cases
		static void staticInit(CRound * ptLaPartie, string imageMurDestructible,
					   string imageMurInDestructible, string imageMurDestruction);
		static void staticDestruct();

		inline bool estMurDestructible()
		{	return _bMurDestructible; }
		inline bool estMurIndestructible()
		{	return _bMurIndestructible; }
		bool estTraversable();			// depend des contenus de la case: bombe, avatar..

		void gereToi();
		void reinitialiserVieDeContenu();
								// Renvoie un booleen indiquant si l'explosion peut se propager
								// apres la case consideree (donc false pour un mur...)
		bool peutSePropager();  // sert pr l'image de la flamme centrale
								// et de la fin de flamme...
		bool poserFlamme(int dureeDeVieFlamme, sens_propagation sens, type_propagation type);

		void afficheToi(SDL_Rect coord_info, SDL_Surface * screen);


	private:
		bool	_bMurDestructible;
		bool	_bMurIndestructible;
		Uint32		_momentDestruction;

		void passerEtatCaseLibre();

		// Pointeur sur la partie (pour obtenir les probabilites des bonus)
		static CRound *	_ptRound;
		static SDL_Surface* _imageMurDestructible;
		static SDL_Surface* _imageMurInDestructible;
		static SDL_Surface* _imageMurDestruction;

		#ifdef DEBUG
			bool verifierCoherence();
		#endif
};



#endif /* CCase_h */
