// CEcranCommandes.cpp: implementation of the cEcranCommandes class.
//
//////////////////////////////////////////////////////////////////////

#include "CEcranCommandes.h"

using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////
//la configCommandes paramtre sera modifie par l'utilisateur
//////////////////////////////////////////////////////////////////////////
CEcranCommandes::CEcranCommandes(SDL_Surface* ecran, int** configCommandes)
:_bruitageDing("menu_ding.wav"),
 _bruitageDone("explosion3.wav")
{
	_ecran = ecran;
	_fondEcran = ImageLoad("images/menus/commandes.bmp");
	_done = false;
//position de la bombe
	//joueur 1
	_position_bombe[0].x = 250;
	_position_bombe[0].y = 315;

	//joueur 2
	_position_bombe[1].x = 250;
	_position_bombe[1].y = 400;
	
	//joueur 3
	_position_bombe[2].x = 250;
	_position_bombe[2].y = 480;

	//joueur 4
	_position_bombe[3].x = 250;
	_position_bombe[3].y = 560;



	//sauver
	_position_bombe[4].x = 185;
	_position_bombe[4].y = 670;

	//quitter
	_position_bombe[5].x = 555;
	_position_bombe[5].y = 670;

	_position_actuelle = 0;

//on charge les images de la bombe
	load_sprite(_bombe_image[1],&_bombe,"images/bombe1.bmp",_ecran,100);
	load_sprite(_bombe_image[2],&_bombe,"images/bombe2.bmp",_ecran,100);
	load_sprite(_bombe_image[3],&_bombe,"images/bombe3.bmp",_ecran,100);
	load_sprite(_bombe_image[4],&_bombe,"images/bombe2.bmp",_ecran,100);
	
	load_sprite(_explosion_image[1],&_explosion,"images/bombex.bmp",_ecran,75);
	load_sprite(_explosion_image[2],&_explosion,"images/bombex2.bmp",_ecran,75);


//et on rentre les paramtres de l'animation
	_bombe.position.x = _position_bombe[_position_actuelle].x;
    _bombe.position.y = _position_bombe[_position_actuelle].y;
	_bombe.to_frame= 4; 
	_bombe.looping_anim = true;

	_explosion.position.x = _position_bombe[_position_actuelle].x;
    _explosion.position.y = _position_bombe[_position_actuelle].y;
	_explosion.to_frame= 2; 
	_explosion.looping_anim = false;

	_configCommandes = configCommandes;
	
	_nombreManettes = SDL_NumJoysticks();	//le nombre de manettes connectees a l'ordi
											//on affichera dans le menu commandes que les manettes
											//connectees
	_nombreCommandes = _nombreManettes + 4;
	_commandeCourante = 0;

	_joueurCourant = 0;
}

//////////////////////////////////////////////////////////////////////////
//liberation images
//////////////////////////////////////////////////////////////////////////
CEcranCommandes::~CEcranCommandes()
{
	int i;
	for	(i=1; i < 5;i++)
	{
		SDL_FreeSurface(_bombe_image[i]);
		if (i < 3)
		{
			SDL_FreeSurface(_explosion_image[i]);
		}
	}
	SDL_FreeSurface(_fondEcran);
}




//////////////////////////////////////////////////////////////////////////
void CEcranCommandes::gereToi()
{
	SDL_Color jaune = {254,252,50};
	TTF_Font* Police;
	SDL_Surface* commandes[4][8];
	int i;
	int j;
	int duree_anim = 500;
	string bidon;
	SDL_Rect positionCommandes[4];
	Uint32 temps_courant = SDL_GetTicks(); 
	Uint32 temps_fin = temps_courant + duree_anim;

	
//on dfinit la font  utiliser.
	Police = TTF_OpenFont("resources/arbli___.ttf",30);
	assert ( Police != NULL);


//gestion de l'affichage du type de commande
	for (i = 0; i< 4; i++)
	{
		commandes[i][0] = TTF_RenderText_Blended(Police,"clavier 1",jaune) ;
		commandes[i][1] = TTF_RenderText_Blended(Police,"clavier 2",jaune) ;
		commandes[i][2] = TTF_RenderText_Blended(Police,"clavier 3",jaune) ;	  
		commandes[i][3] = TTF_RenderText_Blended(Police,"clavier 4",jaune) ;

		commandes[i][4] = TTF_RenderText_Blended(Police,"manette 1",jaune) ;
		commandes[i][5] = TTF_RenderText_Blended(Police,"manette 2",jaune) ;
		commandes[i][6] = TTF_RenderText_Blended(Police,"manette 3",jaune) ;	  
		commandes[i][7] = TTF_RenderText_Blended(Police,"manette 4",jaune) ;
	}	

//on ouvre le fichier de config:
	
	std::ifstream fichierConfig ("config.ini",ios::in);
	//on avance le fichier
	fichierConfig >> _config._nbJoueurs;
	fichierConfig >> _config._nbRounds;
	fichierConfig >> _config._numeroTerrain;
	fichierConfig >> _config._nomTerrain;

	//on lit les valeur des booleens
	for (i=0; i<4; i++)
		fichierConfig >> _configCommandes[0][i];
	
	//on lit les valeur des identifiant
	for (i=0; i<4; i++)
		fichierConfig >> _configCommandes[1][i];

	fichierConfig.close();

	
	positionCommandes[0].x = 655;
	positionCommandes[0].y = 315;

	positionCommandes[1].x = 655;
	positionCommandes[1].y = 400;

	positionCommandes[2].x = 655;
	positionCommandes[2].y = 480;

	positionCommandes[3].x = 655;
	positionCommandes[3].y = 560;
	

	while (! _done )
	{
		gereClavier();
		animation(&_bombe);
		//si le joueur 1  un clavier
		SDL_BlitSurface(_fondEcran,NULL,_ecran,NULL);
		
		for (i=0; i<4; i++)
		{
			if ( _configCommandes[0][i] == 0)
				SDL_BlitSurface( commandes[i][_configCommandes[1][i]], NULL,_ecran,&positionCommandes[i]);
			else
				SDL_BlitSurface( commandes[i][(_configCommandes[1][i]+3)], NULL,_ecran,&positionCommandes[i]);
		}

		SDL_BlitSurface(_bombe_image[_bombe.frame], NULL, _ecran, &_position_bombe[_position_actuelle]);
		SDL_Flip(_ecran);
	}

//si on sort de la boucle, c'est qu'on a appuy sur entre
//animation d'explosion

	while (temps_courant < temps_fin)
	{
		animation(&_explosion);
		SDL_BlitSurface(_fondEcran,NULL,_ecran,NULL);
		SDL_BlitSurface(_explosion_image[_explosion.frame], NULL, _ecran, &_position_bombe[_position_actuelle]);
		SDL_Flip(_ecran);
		temps_courant = SDL_GetTicks();
	}
	
	_done = false;
	_position_actuelle = 0;

	for (i = 0; i< 4; i++)
	{
		for (j=0; j<8; j++)
			SDL_FreeSurface(commandes[i][j]);
	}
	
	TTF_CloseFont(Police);
}



//////////////////////////////////////////////////////////////////////////
//gestion clavier
//haut et bas changent le joueur courant tandis que droite et gauche 
//modifie l'identifiant de controle du joueur courant en fonction de la 
//config materielle (nb de manettes branche)
//////////////////////////////////////////////////////////////////////////
void CEcranCommandes::gereClavier()
{
	SDL_Event event;
      while ( SDL_PollEvent(&event) ) 
	  {	
        if ( event.type == SDL_KEYDOWN ) 
		{
			keystroke=event.key.keysym.sym;

		//haut et bas: navigation entre les options
			if (keystroke==SDLK_UP) 
			{ 
				_bruitageDing.jouer();
				if ( _joueurCourant > 0 && _position_actuelle < 4)
					_joueurCourant--;
		
				if (_position_actuelle > 0 )
					_position_actuelle --;

				else
					_position_actuelle = 5;

				_done = false;
			}


			if (keystroke==SDLK_DOWN) 
			{ 
				_bruitageDing.jouer();
				if (_joueurCourant < 3 && _position_actuelle < 4)
					_joueurCourant++;


				if (_position_actuelle < 5)
					_position_actuelle ++;
		
				else
					_position_actuelle = 0;
				
				_done = false;		
			}
		

		//gauche et droite: modif des options
			if (keystroke == SDLK_RIGHT)
			{
				if (_position_actuelle < 4)
				{
					_bruitageDing.jouer();
					_commandeCourante ++;

					//si on depasse le nombre de commandes, on revient  0;
					if ( _commandeCourante >= _nombreCommandes)
					{
						_commandeCourante = 0;
						_configCommandes[0][_joueurCourant] = 0;
						_configCommandes[1][_joueurCourant] = _commandeCourante;
					}
					
					//dans ce cas, c'est une manette
					if ( _commandeCourante > 3)
					{
						_configCommandes[0][_joueurCourant] = 1;
						_configCommandes[1][_joueurCourant] = _commandeCourante - 3;
					}
					else
						_configCommandes[1][_joueurCourant] = _commandeCourante;
				}
			}

			if (keystroke == SDLK_LEFT)
			{
				if (_position_actuelle < 4)
				{
					_bruitageDing.jouer();
					_commandeCourante --;

					if ( _commandeCourante < 0)
					{
						_commandeCourante = 0;
						_configCommandes[0][_joueurCourant] = 0;
						_configCommandes[1][_joueurCourant] = _commandeCourante;
					}	
						
					// <= 3 c'eest le clavier
					if ( _commandeCourante <= 3)
					{
						_configCommandes[0][_joueurCourant] = 0;
						_configCommandes[1][_joueurCourant] = _commandeCourante;
					}
					else
						_configCommandes[1][_joueurCourant] = _commandeCourante - 3;
				}
			}

			if (keystroke==SDLK_RETURN)
			{
				_bruitageDone.jouer();
				//si entre alors qu'on est sur quitter, on sauve pas
				//EN FAIT, pas de sauvegarde  ce stade (modif tardive)
				//c dans l'ecran d'options qu'on sauve tout
				if ( _position_actuelle == 5)
					_done = true;
				
				else if ( _position_actuelle == 4)
				{
					_done = true;
				}
			}

			if (keystroke==SDLK_ESCAPE)
				exit(0);
		}
      }
      keys = SDL_GetKeyState(NULL);
}




