// CEcranOptions.cpp: implementation of the cEcranOptions class.
//
//////////////////////////////////////////////////////////////////////

#include "CEcranOptions.h"

using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CEcranOptions::CEcranOptions(SDL_Surface* ecran, CConfiguration* configuration)
:_bruitageDing("menu_ding.wav"),
 _bruitageDone("explosion3.wav")
{
	_ecran = ecran;
	_fondEcran = ImageLoad("images/menus/options.bmp");
	_done = false;

	//nb joueurs
	_position_bombe[0].x = 150;
	_position_bombe[0].y = 315;

	//nb rounds
	_position_bombe[1].x = 200;
	_position_bombe[1].y = 400;
	
	//terrain
	_position_bombe[2].x = 350;
	_position_bombe[2].y = 470;

	//Commandes
	_position_bombe[3].x = 300;
	_position_bombe[3].y = 550;



	//sauver
	_position_bombe[4].x = 185;
	_position_bombe[4].y = 670;

	//quitter
	_position_bombe[5].x = 555;
	_position_bombe[5].y = 670;

	_position_actuelle = 0;

//on charge les images de la bombe
	load_sprite(_bombe_image[1],&_bombe,"images/bombe1.bmp",_ecran,100);
	load_sprite(_bombe_image[2],&_bombe,"images/bombe2.bmp",_ecran,100);
	load_sprite(_bombe_image[3],&_bombe,"images/bombe3.bmp",_ecran,100);
	load_sprite(_bombe_image[4],&_bombe,"images/bombe2.bmp",_ecran,100);
	
	load_sprite(_explosion_image[1],&_explosion,"images/bombex.bmp",_ecran,75);
	load_sprite(_explosion_image[2],&_explosion,"images/bombex2.bmp",_ecran,75);


//et on rentre les paramtres de l'animation
	_bombe.position.x = _position_bombe[_position_actuelle].x;
    _bombe.position.y = _position_bombe[_position_actuelle].y;
	_bombe.to_frame= 4; 
	_bombe.looping_anim = true;

	_explosion.position.x = _position_bombe[_position_actuelle].x;
    _explosion.position.y = _position_bombe[_position_actuelle].y;
	_explosion.to_frame= 2; 
	_explosion.looping_anim = false;


//lecture du fichier de configuration, et remplissage de la structure
//config
//si le fichier n'existe pas, on le cre avec des valeurs par dfaut
	_config = configuration; 

	/*
	if (fopen("config.ini", "r") == NULL)
	{		
		ofstream fichierConfig ("config.ini",ios::out);

		fichierConfig << "2" << endl;
		fichierConfig << "2" << endl;
		fichierConfig << "0" << endl;
		fichierConfig << "stage1.dat" << endl;
	}
	
	//sinon, on lit les valeurs inscrites.
	ifstream fichierConfig ("config.ini",ios::in);
	//on affecte aux variables les nombres lus dans le fichier.
	//A FAIRE:EXCEPTIONS!!!!
	
	fichierConfig >> _config->_nbJoueurs;
	fichierConfig >> _config->_nbRounds;
	fichierConfig >> _config->_numeroTerrain;
	fichierConfig >> _config->_nomTerrain;

	fichierConfig.close();
	*/

//ouverture du fichier listant les nivos
//note: on fait comme a car se remettre au debut avec seekg marche
//pas!!! de meme que fermer et rouvrir le fichier
	ifstream fichierNiveaux("niveaux/liste.dat", ios::in);
	string ligne;
	_nbTerrains = 0;
	_terrainCourant = 0;
	
	for (; ! fichierNiveaux.eof(); )
	{
		fichierNiveaux >> ligne;
		_nbTerrains ++;
	}
	fichierNiveaux.close();
	
	ifstream fichierNiveaux2("niveaux/liste.dat", ios::in);
	_terrains = new string[_nbTerrains];
	
	for (; ! fichierNiveaux2.eof(); )
	{
		fichierNiveaux2 >> _terrains[_terrainCourant];
		cout << _terrains[_terrainCourant] << endl;
		_terrainCourant++;
	}
	_terrainCourant = _config->_numeroTerrain;
	fichierNiveaux2.close();
}

//////////////////////////////////////////////////////////////////////////
//liberation surfaces
//////////////////////////////////////////////////////////////////////////
CEcranOptions::~CEcranOptions()
{
	int i;
	SDL_FreeSurface(_fondEcran);
	for	(i=1; i < 5;i++)
	{
		SDL_FreeSurface(_bombe_image[i]);
		if (i < 3)
		{
			SDL_FreeSurface(_explosion_image[i]);
		}
	}
}



//////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////
T_EtatAccueil CEcranOptions::gereToi()
{
	SDL_Color jaune = {254,252,50};
	TTF_Font* Police;
	int i;
	SDL_Surface* chiffres[10];
	SDL_Surface** nomsTerrains = new SDL_Surface*[_nbTerrains];
	int duree_anim = 500;
	Uint32 temps_courant = SDL_GetTicks(); 
	Uint32 temps_fin = temps_courant + duree_anim;
	
	//on dfinit la font  utiliser.
	
	
	Police = TTF_OpenFont("resources/arbli___.ttf",30);
	assert ( Police != NULL);

//gestion de l'affichage du nombre de joueurs
	chiffres[0] = TTF_RenderText_Blended(Police,"0",jaune) ;
	chiffres[1] = TTF_RenderText_Blended(Police,"1",jaune) ;
	chiffres[2] = TTF_RenderText_Blended(Police,"2",jaune) ;	  
	chiffres[3] = TTF_RenderText_Blended(Police,"3",jaune) ;	 
	chiffres[4] = TTF_RenderText_Blended(Police,"4",jaune) ;
	chiffres[5] = TTF_RenderText_Blended(Police,"5",jaune) ;
	chiffres[6] = TTF_RenderText_Blended(Police,"6",jaune) ;
	chiffres[7] = TTF_RenderText_Blended(Police,"7",jaune) ;
	chiffres[8] = TTF_RenderText_Blended(Police,"9",jaune) ;
	chiffres[9] = TTF_RenderText_Blended(Police,"10",jaune) ;
	
	
	SDL_Rect position_joueurs;
	position_joueurs.x = 655;
	position_joueurs.y = 320;

	SDL_Rect position_rounds;
	position_rounds.x = 655;
	position_rounds.y = 405;

	SDL_Rect position_terrain;
	position_terrain.x = 655;
	position_terrain.y = 480;

	
	for (i = 0; i < _nbTerrains; i++)
		nomsTerrains[i] = TTF_RenderText_Blended(Police, _terrains[i].c_str(), jaune);

	SDL_BlitSurface(_fondEcran,NULL,_ecran,NULL);
	SDL_BlitSurface(chiffres[_config->_nbJoueurs],NULL,_ecran, &position_joueurs);
	SDL_BlitSurface(chiffres[_config->_nbRounds],NULL,_ecran, &position_rounds);
	SDL_BlitSurface(nomsTerrains[_terrainCourant],NULL,_ecran, &position_terrain);
	SDL_BlitSurface(_bombe_image[_bombe.frame], NULL, _ecran, &_position_bombe[_position_actuelle]);

	while (! _done )
	{
		gereClavier();
		animation(&_bombe);
		SDL_BlitSurface(_fondEcran,NULL,_ecran,NULL);
		SDL_BlitSurface(chiffres[_config->_nbJoueurs],NULL,_ecran, &position_joueurs);
		SDL_BlitSurface(chiffres[_config->_nbRounds],NULL,_ecran, &position_rounds);
		SDL_BlitSurface(nomsTerrains[_terrainCourant],NULL,_ecran, &position_terrain);
		SDL_BlitSurface(_bombe_image[_bombe.frame], NULL, _ecran, &_position_bombe[_position_actuelle]);
		SDL_Flip(_ecran);
	}
	
//si on sort de la boucle, c'est qu'on a appuy sur entre
//animation d'explosion
	while (temps_courant < temps_fin)
	{
		animation(&_explosion);
		SDL_BlitSurface(_fondEcran,NULL,_ecran,NULL);
		SDL_BlitSurface(_explosion_image[_explosion.frame], NULL, _ecran, &_position_bombe[_position_actuelle]);
		SDL_Flip(_ecran);
		temps_courant = SDL_GetTicks();
	}
	
	_done = false;
	_position_actuelle = 0;
	TTF_CloseFont(Police);

	//liberation mmoire
	for (i=0; i<10; i++)
	{
		SDL_FreeSurface(chiffres[i]);
		if (i<_nbTerrains)
			SDL_FreeSurface(nomsTerrains[i]);
	}
	return ACCUEIL;
}




//////////////////////////////////////////////////////////////////////////
void CEcranOptions::gereClavier()
{
	SDL_Event event;
      while ( SDL_PollEvent(&event) ) 
	  {	
        if ( event.type == SDL_KEYDOWN ) 
		{
			_keystroke=event.key.keysym.sym;

		//haut et bas: navigation entre les options
			if (_keystroke==SDLK_UP) 
			{ 
				_bruitageDing.jouer();
				if (_position_actuelle > 0 )
				{	
					_position_actuelle --;	
					_done = false;
				}
				else
				{
					_position_actuelle = 4;
					_done = false;
				}
				
			}

			if (_keystroke==SDLK_DOWN) 
			{ 
				_bruitageDing.jouer();
				if (_position_actuelle < 5)
				{
					_position_actuelle ++;	
					_done = false;
				}
				else
				{
					_position_actuelle = 0;
					_done = false;
				}
			}
		

		//gauche et droite: modif des options
			if (_keystroke == SDLK_RIGHT)
			{
				_bruitageDing.jouer();
				switch (_position_actuelle)
				{
					//cas 0: nbjoueurs
					case 0: if ( _config->_nbJoueurs  < 4)
								_config->_nbJoueurs++;
							break;
					//cas 1: nbrounds
					case 1: if ( _config->_nbRounds  < 4)
								_config->_nbRounds++;
							break;

					//cas 2: terrains
					case 2: if ( _terrainCourant  < _nbTerrains-1)
								_terrainCourant++;
							break;
				}
			}

			if (_keystroke == SDLK_LEFT)
			{
				_bruitageDing.jouer();
				switch (_position_actuelle)
				{
					//cas 0: nbjoueurs
					case 0: if (_config->_nbJoueurs > 1)
								_config->_nbJoueurs --;
							break;

					//cas 1: nbrounds
					case 1: if (_config->_nbRounds > 1)
								_config->_nbRounds --;

							break;

					//cas 2: terrains
					case 2: if (_terrainCourant > 0)
								_terrainCourant --;
							break;
				}
			}

			if (_keystroke==SDLK_RETURN)
			{
				_bruitageDone.jouer();
				//si entre alors qu'on est sur quitter, on sauve pas
				if ( _position_actuelle == 5)
					_done = true;
				
				else if ( _position_actuelle == 4)
				{
					sauverConfig();
					_done = true;
				}
				else if (_position_actuelle == 3)
				{
					CEcranCommandes ecranCommandes(_ecran, _config->_configCommandes);
					ecranCommandes.gereToi();
				}
				
			}
			
			if (_keystroke==SDLK_ESCAPE)
				exit(0);
		}
      }
      _keys = SDL_GetKeyState(NULL);
}


//////////////////////////////////////////////////////////////////////////
void CEcranOptions::sauverConfig()
{
	int i;
	ofstream fichierConfig ("config.ini",ios::out);
	fichierConfig << _config->_nbJoueurs << endl ;
	fichierConfig << _config->_nbRounds<< endl ;
	fichierConfig << _terrainCourant << endl ;
	fichierConfig << _terrains[_terrainCourant] << endl ;

	//on ecrit les valeur des booleens
	for (i=0; i<4; i++)
		fichierConfig << _config->_configCommandes[0][i] << endl;

	//on ecrit les valeur des identifiant
	for (i=0; i<4; i++)
		fichierConfig << _config->_configCommandes[1][i] << endl;
	
	fichierConfig.close();
}


