
/*-----------------------------------------------------------------
/					 Fichier  CFlamme.cpp
/------------------------------------------------------------------
Role: implmentation de la classe CFlamme
-------------------------------------------------------------------
Versions: (depuis regroupement du 22/12/02)
-------------------------------------------------------------------
23/12/02: regroupement des modifs de Fran et Guillaume
	Rajout des fonctions chargerImages et supprimerImages,
	Modification du constructeur
	
------------------------------------------------------------------*/

#include "CFlamme.h"

SDL_Surface* CFlamme::_imagesPropagation[5][2];
SDL_Surface** CFlamme::_imagesFlammeCentrale = NULL; 


//---CONSTRUCTEUR
CFlamme::CFlamme(int dureeDeVieFlamme, sens_propagation sens, type_propagation type)
: _momentFinFlamme(SDL_GetTicks() + dureeDeVieFlamme)
{
	//choix de l'image en fonction du sens de propagation et du type
	_image = _imagesPropagation[sens][type];
}


//---DESTRUCTEUR
CFlamme::~CFlamme()
{}


void CFlamme::toucheAvatar(CAvatar * ptAvatar)
{
	ptAvatar->enflammeToi();
}
/*
int CFlamme::continueDestruction()
{
	_estBienDetruit = true;
	return -1;
}

bool CFlamme::estTraversable()
{
	return true;
}
*/
	
void CFlamme::vis2()
{
	if ( SDL_GetTicks() >= _momentFinFlamme)
		_aDetruire = true;
}



void CFlamme::afficheToi(SDL_Rect coord_info, SDL_Surface * screen)
{
	SDL_SetColorKey(_image, SDL_SRCCOLORKEY, SDL_MapRGB(screen->format,0,0,255));
	SDL_BlitSurface(_image,NULL,screen,&coord_info);
}


void CFlamme::staticInit()
{
	assert (_imagesPropagation != NULL);

	CFlamme::_imagesPropagation[HAUT][NORMAL] = ImageLoad("images/flammes/verticale.bmp");
	CFlamme::_imagesPropagation[HAUT][FIN_FLAMME] = ImageLoad("images/flammes/haut_fin.bmp");

	CFlamme::_imagesPropagation[BAS][NORMAL] = ImageLoad("images/flammes/verticale.bmp");
	CFlamme::_imagesPropagation[BAS][FIN_FLAMME] = ImageLoad("images/flammes/bas_fin.bmp");

	CFlamme::_imagesPropagation[GAUCHE][NORMAL] = ImageLoad("images/flammes/horizontale.bmp");
	CFlamme::_imagesPropagation[GAUCHE][FIN_FLAMME] = ImageLoad("images/flammes/gauche_fin.bmp");

	CFlamme::_imagesPropagation[DROITE][NORMAL] = ImageLoad("images/flammes/horizontale.bmp");
	CFlamme::_imagesPropagation[DROITE][FIN_FLAMME] = ImageLoad("images/flammes/droite_fin.bmp");

	CFlamme::_imagesPropagation[CENTRAL][NORMAL] = ImageLoad("images/flammes/centrale.bmp");
	CFlamme::_imagesPropagation[CENTRAL][FIN_FLAMME] = ImageLoad("images/flammes/centrale.bmp");
}

void CFlamme::staticDestruct()
{
	for (int i=0; i<5; i++)
	{
		for (int j=0; j < 2; j++)
		{
			SDL_FreeSurface(_imagesPropagation[i][j]);	
		}
	}
}



