/*-----------------------------------------------------------------
/					 Fichier d'entete CFlamme.h
/------------------------------------------------------------------
Role: dclaration de la classe CFlamme
-------------------------------------------------------------------
Versions: (depuis regroupement du 22/12/02)
-------------------------------------------------------------------
23/12/02: regroupement des modifs de Fran et Guillaume
	Rajout des fonctions chargerImages et supprimerImages, des 
	variables _imagesPropagation et _imagesFlammeCentrale
	Rajout de paramtres au constructeur
	
------------------------------------------------------------------*/

#if !defined(CFlamme_h)
#define CFlamme_h


#include "CContenu.h"
#include "CCase.h"
#include "CAvatar.h"
#include "utils.h"


class CFlamme : public CContenu
{

public:
	CFlamme(int dureeDeVieFlamme, sens_propagation sens, type_propagation type);
	virtual ~CFlamme();
	virtual void toucheAvatar(CAvatar * ptAvatar);
	inline int continueDestruction()
	{	_estBienDetruit = true; return -1; }
	inline bool estTraversable()
	{	return true; }
	void afficheToi(SDL_Rect coord_info, SDL_Surface * screen);

	static void staticInit();
	static void staticDestruct();
	
private:
	void vis2();
	Uint32	_momentFinFlamme;

	static SDL_Surface* _imagesPropagation[5][2];
	static SDL_Surface** _imagesFlammeCentrale; //car 10 possibilits de flamme centrale!
												//pas encore utilise

};



#endif
