#include "CGestionnaireGamepad.h"

CGestionnaireGamepad::CGestionnaireGamepad(int numeroGamepad)
:_gamepad(SDL_JoystickOpen(numeroGamepad)),
 _numeroGamepad(numeroGamepad)
{
	SDL_JoystickEventState(SDL_ENABLE);
}


SDeplacement CGestionnaireGamepad::getDeplacement(int numeroAvatar)
{
	SDL_JoystickUpdate();

	SDeplacement deplacement = {0,0,0,0};


	if ( SDL_JoystickGetAxis(tabTGamepadDirections[HAUT].whichGamepad,
		tabTGamepadDirections[HAUT].whichAxis) * tabTGamepadDirections[HAUT].signe > GAMEPAD_DEPLACEMENT_MINIMUM )

		deplacement.y1erChoix = 1;

	else if ( SDL_JoystickGetAxis(tabTGamepadDirections[BAS].whichGamepad,
		tabTGamepadDirections[BAS].whichAxis) * tabTGamepadDirections[BAS].signe > GAMEPAD_DEPLACEMENT_MINIMUM )

		deplacement.y1erChoix = -1;

	else if ( SDL_JoystickGetAxis(tabTGamepadDirections[GAUCHE].whichGamepad,
		tabTGamepadDirections[GAUCHE].whichAxis) * tabTGamepadDirections[GAUCHE].signe > GAMEPAD_DEPLACEMENT_MINIMUM )

		deplacement.x1erChoix = -1;

	else if ( SDL_JoystickGetAxis(tabTGamepadDirections[DROITE].whichGamepad,
		tabTGamepadDirections[DROITE].whichAxis) * tabTGamepadDirections[DROITE].signe > GAMEPAD_DEPLACEMENT_MINIMUM )

		deplacement.x1erChoix = 1;


	return deplacement;
}

SAction CGestionnaireGamepad::getAction(int numeroAvatar)
{
	SAction action = {false, false};

	action.bouton1 = SDL_JoystickGetButton(_gamepad,0) != 0;
	action.bouton1 = SDL_JoystickGetButton(_gamepad,1) != 0;
	return action;
}


// Appuyer sur echapp pour abandonner
bool CGestionnaireGamepad::configurerDirection(eDirections direction)
{
	
	bool configOK = false;
	SDL_Event event;


	while (!configOK)
	{
		while(SDL_WaitEvent(&event))
		{
			switch(event.type)
			{
				case SDL_JOYAXISMOTION:
					if ( abs(event.jaxis.value) > GAMEPAD_DEPLACEMENT_MINIMUM )
					{	// Rque: abs vient de <stdlib.h> ou <math.h>
						tabTGamepadDirections[direction].whichGamepad = event.jaxis.axis;
						tabTGamepadDirections[direction].whichAxis = event.jaxis.which;
						tabTGamepadDirections[direction].signe = ( event.jaxis.value >= 0 ? 1 : -1 );
						configOK = true;
					}
					else
						;	// le deplacement est trop faible, on en attend un plus fort...
							// ca permet d'viter de prendre en compte des 
							// dplacements involontaires des joysticks analogiques
					break;
				case SDL_KEYDOWN:	// en cas d'appui sur 'echap' on abandonne la configuration
					if ( event.key.keysym.sym == SDLK_ESCAPE )
						return false;
				default:
					;		// on ne fait rien
			}
	
		}
	}
	return true;


}

