///////////////////////////////////////////////////////////////////////////////////
//
// 12/01/02 - Francois - Decouverte d'un bug sous Linux: on ne peut pas lancer 2
//			a suivre le programme en plein ecran. Bug incomprehensible...
//			=> DIFFERENCE de code entre WIN32 et Linux
/////////////////////////////////////////////////////////////////////////////////// 


#include <stdlib.h>
#include <fstream.h>
#include <iostream> 	//pr la lecture d'un fichier 
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>

#include "CInterfaceAccueil.h"
#include "CPartie.h"
#include "CConfiguration.h"
#include "utils.h"

void check_keyboard(void);

SDL_Surface *screen;		//la surface sur laquelle on va blitter toutes les images
							//par la suite
SDL_Surface *ecran_accueil;


Uint8* keys;
int keystroke;
Uint32 blue;
int done=0;

//#include "fmod.h"


//cette fonction est execut lors d'un appel a exit
void NettoyageEnSortie()
{
	FSOUND_Close();
	SDL_Quit();
}


//////////////////////////////////////////////////////
//le main: 
//-initialisation des bibliothques SDL, FMOD, SDL_TTF
//-lancement de la boucle d'interface.
//////////////////////////////////////////////////////
int main(int argc, char **argv)
{
	
	CConfiguration config;
	atexit(NettoyageEnSortie);
	
	//initialisations
	//on test si on peut initialiser l'cran, si non, on quitte
	if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK ) <0 ) exit(1); 

	//initialisation de FMOD
	if (!FSOUND_Init(44100, 64, FSOUND_INIT_GLOBALFOCUS))
	{
		printf("Probleme a l'initialisation de FSOUND...\n");
		exit(1);
	}
	
#ifdef WIN32	// permet d'eviter le bug sous Linux quand on lance 2* le programme en plein ecran
	//Par defaut, on lance en plein ecran sous windows
	if (argc == 2)
	{
		if ( argv[1][0] == 'w')
			screen = SDL_SetVideoMode(1024, 768, 32, SDL_SWSURFACE | SDL_DOUBLEBUF /*| SDL_FULLSCREEN*/);                         
		else
			exit(0);
	}
	else
		screen=SDL_SetVideoMode(1024, 768, 32, SDL_SWSURFACE | SDL_DOUBLEBUF | SDL_FULLSCREEN);                         
#else
	screen=SDL_SetVideoMode(1024, 768, 32, SDL_SWSURFACE | SDL_DOUBLEBUF /*| SDL_FULLSCREEN*/);
#endif


	if (screen==NULL) { exit(1); }

	//on charge l'cran de prsentation
	blue=SDL_MapRGB(screen->format, 0x00,0x00,0xFF);
	ecran_accueil=ImageLoad("images/menus/accueil.bmp");
	
	

	//initialisation du moteur de police
	TTF_Init();
	
	//chargement de l'image d'accueil. On quitte l'image en appuyant sur entre
	SDL_FillRect(screen, NULL, blue);
	SDL_BlitSurface(ecran_accueil,NULL,screen,NULL);
	SDL_Flip(screen);

	while ( ! done ) 
	{
		check_keyboard();
  	}
	

	SDL_FreeSurface(ecran_accueil);


	// boucle principale: cration de l'interface accueil qui gre l'interface
	CInterfaceAccueil Accueil(screen, &config);
	T_EtatAccueil etat = ACCUEIL;
	while ( etat != QUITTER ) 
	{
		
		Accueil.setEtat(ACCUEIL);
		etat = Accueil.run();
		
		//tant que run() s'execute, c'est qu'on navigue dans les menus
		//si run a fini, un etat est renvoy: QUITTER, ou encore PARTIE
		if (etat == PARTIE)
		{			
			cPartie NouvellePartie(screen);
			NouvellePartie.run();
		}
  	}
	
  return 1;
}




//fonction qui scanne le clavier. Un appui sur entre ou echap fera
//quitter l'cran d'accueil (le premier du jeu)
void check_keyboard(void)
{ 
	SDL_Event event;
      while ( SDL_PollEvent(&event) ) 
	  {	
        if ( event.type == SDL_KEYDOWN ) 
		{
			keystroke=event.key.keysym.sym;
			if (keystroke==SDLK_ESCAPE) 
			{ 
				done = 1; 
			}
			
			if (keystroke==SDLK_RETURN)
			{
				done = 1; //un appui sur entre passe le premier cran
			}
		}
      }
      keys = SDL_GetKeyState(NULL);
}
